% M106 Winter 2021, Data-driven UQ
% by Yoonsang Lee (yoonsang.lee@dartmouth.edu)
%
% Lecture 9: MCMC
%
% Markov Chain Monte Carlo sample using
% the Metropolis-Hastings Algorithm
%
% Last update: Jan 25, 2020

%target = @(x) 1/(1+x.^2)/pi;
target = @(x) exp(-(x+10).^2)+exp(-(x-10).^2);

b=10; % Variance of the proposal Gaussian denstiy

niters = 50000;
naccept = 0;

theta = 0; % initial value for the Markov chain

samples = zeros(niters+1,1);
samples(1) = theta; % initial location of the chain

for i=1:niters
    theta_p = theta + randn()*b;
    rho = min(1, target(theta_p)/target(theta)); %rho = r in the slides
    u = rand(); % u is uniform in (0,1)
    if u<rho
        naccept = naccept+1;
        theta = theta_p;
    end
    samples(i+1)=theta;
end

hist(samples,100)
